[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

Re: Bug#704073: [multipath-tools-boot] error when update-initramfs



On Monday 10 June 2013 08:52 PM, Ritesh Raj Sarraf wrote:
> On Monday 10 June 2013 08:12 PM, Adam D. Barratt wrote:
>> For the record, the window for getting fixes in to the upcoming point
>> release closed yesterday.
>>
>> Getting the fixes in to sid would be appreciated in any case, so that
>> we can look at a p-u update for 7.2. 
> I will get it done for sid right now.
>

Attached is the diff for Wheezy next. Please review and confirm. THen
I'll upload.

-- 
Ritesh Raj Sarraf | http://people.debian.org/~rrs
Debian - The Universal Operating System

diff -Nru multipath-tools-0.4.9+git0.4dfdaf2b/debian/changelog multipath-tools-0.4.9+git0.4dfdaf2b/debian/changelog
--- multipath-tools-0.4.9+git0.4dfdaf2b/debian/changelog	2012-05-28 18:20:11.000000000 +0530
+++ multipath-tools-0.4.9+git0.4dfdaf2b/debian/changelog	2013-06-11 00:19:19.000000000 +0530
@@ -1,3 +1,19 @@
+multipath-tools (0.4.9+git0.4dfdaf2b-7+stable1) stable-proposed-updates; urgency=low
+
+  * 0.4.9+git0.4dfdaf2b-7 for Wheezy point-in-time update inclusion 
+
+ -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 11 Jun 2013 00:17:36 +0530
+
+multipath-tools (0.4.9+git0.4dfdaf2b-7) unstable; urgency=low
+
+  * [8c5d841] Fix upstream copy of kpartx rules (Closes: #618700)
+  * [a3a6c10] Call PREREQS before calling scripts/functions.
+    Thanks to Guy Rossin, Michael Prokop
+  * [7572c53] Don't plain exit if root is on multipath device.
+    Thanks to Guy Rossin (Closes: #704073)
+
+ -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 11 Jun 2013 00:14:50 +0530
+
 multipath-tools (0.4.9+git0.4dfdaf2b-6) unstable; urgency=low
 
   * [821cc20] Don't fail if no dm aware (root) device is reported
diff -Nru multipath-tools-0.4.9+git0.4dfdaf2b/debian/initramfs/init-top multipath-tools-0.4.9+git0.4dfdaf2b/debian/initramfs/init-top
--- multipath-tools-0.4.9+git0.4dfdaf2b/debian/initramfs/init-top	2012-05-28 18:20:11.000000000 +0530
+++ multipath-tools-0.4.9+git0.4dfdaf2b/debian/initramfs/init-top	2013-06-11 00:19:19.000000000 +0530
@@ -2,6 +2,17 @@
 #
 # multipath hardware handler
 
+PREREQ=" "
+
+prereqs() { echo "$PREREQ"; }
+
+case $1 in
+prereqs)
+	prereqs
+	exit 0
+	;;
+esac
+
 . /scripts/functions
 
 verbose()
diff -Nru multipath-tools-0.4.9+git0.4dfdaf2b/debian/kpartx.udev multipath-tools-0.4.9+git0.4dfdaf2b/debian/kpartx.udev
--- multipath-tools-0.4.9+git0.4dfdaf2b/debian/kpartx.udev	2012-05-28 18:20:11.000000000 +0530
+++ multipath-tools-0.4.9+git0.4dfdaf2b/debian/kpartx.udev	1970-01-01 05:30:00.000000000 +0530
@@ -1,40 +0,0 @@
-#
-# persistent links for device-mapper devices
-# only hardware-backed device-mapper devices (ie multipath, dmraid,
-# and kpartx) have meaningful persistent device names
-#
-
-KERNEL!="dm-*", GOTO="kpartx_end"
-ACTION=="remove", GOTO="kpartx_end"
-
-# This is a temporary hack until Debian's dmsetup properly supports "dmsetup
-# export". For more information see: #434241, #487881, #493078
-IMPORT{program}="dmsetup_env %M %m"
-
-ENV{DM_TABLE_STATE}!="LIVE", GOTO="kpartx_end"
-
-ENV{DM_UUID}=="?*", IMPORT{program}=="kpartx_id %M %m $env{DM_UUID}"
-
-OPTIONS="link_priority=50"
-
-# Create persistent links for multipath tables
-ENV{DM_UUID}=="mpath-*", \
-	SYMLINK+="disk/by-id/$env{DM_TYPE}-$env{DM_NAME}"
-
-# Create persistent links for dmraid tables
-ENV{DM_UUID}=="dmraid-*", \
-        SYMLINK+="disk/by-id/$env{DM_TYPE}-$env{DM_NAME}"
-
-# Create persistent links for partitions
-ENV{DM_PART}=="?*", \
-        SYMLINK+="disk/by-id/$env{DM_TYPE}-$env{DM_NAME}-part$env{DM_PART}"
-
-# Create dm tables for partitions
-ENV{DM_STATE}=="ACTIVE", ENV{DM_UUID}=="mpath-*", \
-        RUN+="/sbin/kpartx -a -p -part /dev/$name"
-ENV{DM_STATE}=="ACTIVE", ENV{DM_UUID}=="dmraid-*", \
-        RUN+="/sbin/kpartx -a -p -part /dev/$name"
-
-LABEL="kpartx_end"
-
-
diff -Nru multipath-tools-0.4.9+git0.4dfdaf2b/debian/multipath-tools.init multipath-tools-0.4.9+git0.4dfdaf2b/debian/multipath-tools.init
--- multipath-tools-0.4.9+git0.4dfdaf2b/debian/multipath-tools.init	2012-05-28 18:20:11.000000000 +0530
+++ multipath-tools-0.4.9+git0.4dfdaf2b/debian/multipath-tools.init	2013-06-11 00:19:19.000000000 +0530
@@ -36,7 +36,7 @@
 		tablename=$(dmsetup table --target multipath | sed -n "s/\(.*\): .* $dev .*/\1/p")
 		if ! [ -z $tablename ]; then
 			log_daemon_msg "Root is on a multipathed device, multipathd can not be stopped"
-			exit 1
+			DONT_STOP_MPATHD=1
 		fi
 	else
 		local_slave=`readlink -f $slave`;
@@ -49,7 +49,7 @@
 		tablename=$(dmsetup table --target multipath | sed -n "s/\(.*\): .* $dev .*/\1/p")
 		if ! [ -z $tablename ]; then
 			log_daemon_msg "Root is on a multipathed device, multipathd can not be stopped"
-			exit 1
+			DONT_STOP_MPATHD=1
 		fi
 fi
 }
@@ -62,6 +62,7 @@
 	log_end_msg $?
 	;;
   stop)
+	DONT_STOP_MPATHD=0
         root_dev=$(awk '{ if ($1 !~ /^[ \t]*#/ && $1 ~ /\// && $2 == "/") { print $1; }}' /etc/mtab)
 	dm_num=$(dmsetup info -c --noheadings -o minor $root_dev 2>/dev/null)
 	if [ $? -ne 0 ]; then
@@ -74,9 +75,11 @@
 		[ -d $syspath/$root_dm_device ] && teardown_slaves $syspath/$root_dm_device
 	fi
 
-	log_daemon_msg "Stopping $DESC" "$NAME"
-	start-stop-daemon --oknodo --stop --quiet --pidfile /var/run/$NAME.pid --exec $DAEMON
-	log_end_msg $?
+	if [ x$DONT_STOP_MPATHD = x0 ]; then
+		log_daemon_msg "Stopping $DESC" "$NAME"
+		start-stop-daemon --oknodo --stop --quiet --pidfile /var/run/$NAME.pid --exec $DAEMON
+		log_end_msg $?
+	fi
 	;;
   reload|force-reload)
 	log_daemon_msg "Reloading $DESC" "$NAME"
diff -Nru multipath-tools-0.4.9+git0.4dfdaf2b/debian/rules multipath-tools-0.4.9+git0.4dfdaf2b/debian/rules
--- multipath-tools-0.4.9+git0.4dfdaf2b/debian/rules	2012-05-28 18:20:11.000000000 +0530
+++ multipath-tools-0.4.9+git0.4dfdaf2b/debian/rules	2013-06-11 00:19:19.000000000 +0530
@@ -25,6 +25,8 @@
 
 build-stamp:
 	dh_testdir
+	
+	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
 
 	$(MAKE) $(OPTFLAGS) LIB=lib
 

Attachment: signature.asc
Description: OpenPGP digital signature


Reply to: